%Program to evaluate each of the data sets:
%Here are several TP files from MEEI data set.  One contains a 'perfect' probe calibration results.  The other four (a-d) were measured back to back on the same day with very similar control results - passed but not perfect.  Must be very frustrating.  What is the difference (causes) between the perfect and not so perfect?  The problem region for not so perfect is in 1.5 to 5 kHz region.  We talked about steel wire.  I think one of the major issues is with the ear tips.  We can compare a brand new tip vs. a repeatedly used tip vs. not well-glued tip.  

clear all;close all
load ./Data/lastTPData_Perfect.mat
F=f/1e3;
df=f(2)-f(1);

fig(1);
plot(Us);grid;title('perfect')

fig(2);
loglog(F,abs(Pl4ch1(:,4)));hold on
loglog(F,abs(Pl4ch1(:,3)),'r')
loglog(F,abs(Pl4ch1(:,2)),'g')
loglog(F,abs(Pl4ch1(:,1)),'c')
hold off; xlim([0.1 10]);grid on


fig(3);
%try to remove the pole in the data
%F= 1e-3*df*(1:fix(1e4/df))'; %Work with extended freq range
s=i*2*pi*F; %compute along the j\omega axis
s3=2*pi*(-0.022+3.873i);
%s4=2*pi*(-0.026+5039i);
%P3=((s+.026).^2)./( (s+s3).*( s+s3.' ) ); %Pole pair
Z2=(s-s3)./s3; %This only includes the 2d quad zero
Z3=(s-s3')./s3'; %This is the 3d quad zero over positive freqs
%Z2=Z2./s;Z3=Z3./s;
Z=Z2.*Z3;

subplot(211); %Plot mag and phase of Z2,Z3,Z
loglog(F,abs(Z2),'r.-', F,abs(Z3),'g--',F,abs(Z),'b');grid on;
ylim([.01 5]);title('red: |j\omega-s_+|; green: |j\omega-s_-|; blue: (j\omega-s_+)(j\omega-s_-)');
subplot(212)
semilogx(F,angle(Z2)/pi,'r.-', F,angle(Z3)/pi,'g--',F,angle(Z)/pi,'b');grid on;
xlabel('Freq [kHz]');ylabel('\angle [Rad/pi]')

k=120:190;
fig(4);
R12=[Pl4ch1(:,4)./Pl4ch1(:,1),Pl4ch1(:,3)./Pl4ch1(:,1)];
R12=1./R12;
subplot(211)
semilogy(F,abs(R12(:,1)),'r', F,abs(1.9./Z),'g' ,F(k),abs(R12(k,1).*Z(k)),'b');grid
ylim([1,200]);
subplot(212)
plot(F,unwrap(angle(R12(:,1))),F,unwrap(angle(R12(:,1).*Z)),'b');grid

fig(5);
E=R12(:,1).*Z;

plot(E(k));grid;hold on
plot(E(k(1:20)),'og')
plot(E(k(end)-20:k(end)),'or');
hold off
title('green: start frequency; red: stop freq; ')


